var ModelNameState = false;
var ModelPathState = false;
var ModelUserState = false;
var ModelPwdState = false;
if (jQuery)(function($) {
  $.extend($.fn, {
    fileTree: function(o, h) {
      // Defaults
      if (!o) var o = {};
      if (o.root == undefined) o.root = '/';
      if (o.script == undefined) o.script = 'jqueryFileTree.php';
      if (o.folderEvent == undefined) o.folderEvent = 'click';
      if (o.expandSpeed == undefined) o.expandSpeed = 200;
      if (o.collapseSpeed == undefined) o.collapseSpeed = 200;
      if (o.expandEasing == undefined) o.expandEasing = null;
      if (o.collapseEasing == undefined) o.collapseEasing = null;
      if (o.multiFolder == undefined) o.multiFolder = true;
      if (o.loadMessage == undefined) o.loadMessage = 'Loading...';
      $(this).each(function() {
        function showTree(c, t) {
          $(c).addClass('wait');
          $(".isoJqueryFileTree.start").remove();
          $.post(o.script, {
            dir: t
          }, function(data) {
            $(c).find('.start').html('');
            $(c).removeClass('wait').append(data);
            if (o.root == t) $(c).find('UL:hidden').show();
            else $(c).find('UL:hidden').slideDown({
              duration: o.expandSpeed,
              easing: o.expandEasing
            });
            bindTree(c);
          });
        }

        function bindTree(t) {
          $(t).find('LI A').bind(o.folderEvent, function() {
            if ($(this).parent().hasClass('directory')) {
              if ($(this).parent().hasClass('collapsed')) {
                // Expand
                if (!o.multiFolder) {
                  $(this).parent().parent().find('UL').slideUp({
                    duration: o.collapseSpeed,
                    easing: o.collapseEasing
                  });
                  $(this).parent().parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                }
                $(this).parent().find('UL').remove(); // cleanup
                showTree($(this).parent(), escape($(this).attr('rel').match(/.*\//)));
                $(this).parent().removeClass('collapsed').addClass('expanded');
              } else {
                // Collapse
                $(this).parent().find('UL').slideUp({
                  duration: o.collapseSpeed,
                  easing: o.collapseEasing
                });
                $(this).parent().removeClass('expanded').addClass('collapsed');
              }
              h($(this).attr('rel'));
            }
            return false;
          });
          // Prevent A from triggering the # on non-click events
          if (o.folderEvent.toLowerCase != 'click') $(t).find('LI A').bind('click', function() {
            return false;
          });
        }
        // Loading message
        $(this).html('<ul class="isoJqueryFileTree start"><li class="wait">' + o.loadMessage + '<li></ul>');
        // Get the initial file list
        showTree($(this), escape(o.root));
      });
    }
  });

})(jQuery);

//keyup输入监听事件
jQuery('#add_rsyncmodule_name').keyup(function() {
  checkModelNameInput();
});

jQuery('#add_rsyncmodule_path').keyup(function() {
  checkModelPathInput();
});
jQuery('#add_rsyncmodule_user').keyup(function() {
  checkModuleUserInput();
});

jQuery('#add_rsyncmodule_password').keyup(function() {
  checkModulePasswordInput();
});

//粘贴监听事件
document.querySelector('#add_rsyncmodule_name').addEventListener("paste", function(e) {
  if (!(e.clipboardData && e.clipboardData.items)) {
    return;
  }

  for (var i = 0, len = e.clipboardData.items.length; i < len; i++) {
    var item = e.clipboardData.items[i];

    if (item.kind === "string") {
      item.getAsString(function(str) {
        // str 是获取到的字符串
        checkModelNameInput();
      })
    } else if (item.kind === "file") {
      var pasteFile = item.getAsFile();
      // pasteFile就是获取到的文件
    }
  }
});

document.querySelector('#add_rsyncmodule_path').addEventListener("paste", function(e) {
  if (!(e.clipboardData && e.clipboardData.items)) {
    return;
  }

  for (var i = 0, len = e.clipboardData.items.length; i < len; i++) {
    var item = e.clipboardData.items[i];

    if (item.kind === "string") {
      item.getAsString(function(str) {
        // str 是获取到的字符串
        checkModelPathInput();
      })
    } else if (item.kind === "file") {
      var pasteFile = item.getAsFile();
      // pasteFile就是获取到的文件
    }
  }
});

document.querySelector('#add_rsyncmodule_user').addEventListener("paste", function(e) {
  if (!(e.clipboardData && e.clipboardData.items)) {
    return;
  }

  for (var i = 0, len = e.clipboardData.items.length; i < len; i++) {
    var item = e.clipboardData.items[i];

    if (item.kind === "string") {
      item.getAsString(function(str) {
        // str 是获取到的字符串
        checkModuleUserInput();
      })
    } else if (item.kind === "file") {
      var pasteFile = item.getAsFile();
      // pasteFile就是获取到的文件
    }
  }
});

document.querySelector('#add_rsyncmodule_password').addEventListener("paste", function(e) {
  if (!(e.clipboardData && e.clipboardData.items)) {
    return;
  }

  for (var i = 0, len = e.clipboardData.items.length; i < len; i++) {
    var item = e.clipboardData.items[i];

    if (item.kind === "string") {
      item.getAsString(function(str) {
        // str 是获取到的字符串
        checkModulePasswordInput();
      })
    } else if (item.kind === "file") {
      var pasteFile = item.getAsFile();
      // pasteFile就是获取到的文件
    }
  }
});

//用户向input尝试输入监听事件
document.querySelector('#add_rsyncmodule_name').addEventListener("input", function(e) {
  checkModelNameInput();
});
document.querySelector('#add_rsyncmodule_path').addEventListener("input", function(e) {
  checkModelPathInput();
});
document.querySelector('#add_rsyncmodule_user').addEventListener("input", function(e) {
  checkModuleUserInput();
});



function checkModelNameInput() {
  var username = "";
  var reg = /^[a-zA-Z]{1}[a-zA-Z0-9_-]{0,127}$/;
  var rsyncmodule_name = jQuery.trim(jQuery('#add_rsyncmodule_name').val());
  if (rsyncmodule_name.length == 0) {
    jQuery('#add_rsyncmodule_name').attr('class', 'unas_input_error');
    jQuery("#add_rsyncmodule_name_warning").text(UNAS._('##$@rsync@$##The Module name consists of English letters, underscores,crossbar and numbers. The first character is a letter##$@rsync@$##'));
    jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon_error");
    jQuery("#add_rsyncmodule_name_warning_icon").attr('title', UNAS._('##$@rsync@$##The Module name consists of English letters, underscores,crossbar and numbers. The first character is a letter##$@rsync@$##'));
    ModelNameState = false;
    checkAddModuleSubmit();
    return ModelNameState;
  } else {
    if (rsyncmodule_name.length > 128) {
      jQuery('#add_rsyncmodule_name').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_name_warning").text(UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_name_warning_icon").attr('title', UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      ModelNameState = false;
      checkAddModuleSubmit();
      return ModelNameState;
    } else if (!reg.test(rsyncmodule_name)) {
      jQuery('#add_rsyncmodule_name').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_name_warning").text(UNAS._('##$@rsync@$##The Module name consists of English letters, underscores,crossbar and numbers. The first character is a letter##$@rsync@$##'));
      jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_name_warning_icon").attr('title', UNAS._('##$@rsync@$##The Module name consists of English letters, underscores,crossbar and numbers. The first character is a letter##$@rsync@$##'));
      ModelNameState = false;
      checkAddModuleSubmit();
      return ModelNameState;
    }
  }
  jQuery.ajax({
    url: "/apps/rsync/include/service_rsync.php",
    type: "POST",
    async: true,
    timeout: 20000,
    data: {
      "action": "getRsyncServerInfo"
    },
    dataType: "json",
    success: function(data) {
      var isexists = false;
      for (var i = 0; i < data.modules.length; i++) {
        if (rsyncmodule_name == data.modules[i].modulename) {
          isexists = true;
          break;
        }
      }

      if (isexists) {
        //有相同的名称
        ModelNameState = false;
        jQuery('#add_rsyncmodule_name').attr('class', 'unas_input_error');
        jQuery("#add_rsyncmodule_name_warning").text(UNAS._('##$@rsync@$##The same module name already exists##$@rsync@$##'));
        jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon_error");
        jQuery("#add_rsyncmodule_name_warning_icon").attr('title', UNAS._('##$@rsync@$##The same module name already exists##$@rsync@$##'));
        checkAddModuleSubmit();
        return ModelNameState;
      } else {
        ModelNameState = true;
        jQuery('#add_rsyncmodule_name').attr('class', 'unas_input');
        jQuery("#add_rsyncmodule_name_warning").text('');
        jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon");
        jQuery("#add_rsyncmodule_name_warning_icon").attr('title', '');
        checkAddModuleSubmit();
        return (ModelNameState);

      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //请求超时
      ModelNameState = false;
      jQuery('#add_rsyncmodule_name').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_name_warning").text(UNAS._('##$@rsync@$##Request timeout##$@rsync@$##'));
      jQuery("#add_rsyncmodule_name_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_name_warning_icon").attr('title', UNAS._('##$@rsync@$##Request timeout##$@rsync@$##'));
      checkAddModuleSubmit();
      return ModelNameState;

    }
  });

}

function checkModelPathInput() {
  var rsyncmodule_path = "";
  var reg = /^[a-zA-Z]{1}[a-zA-Z0-9_-]{0,127}$/;
  var rsyncmodule_path = jQuery.trim(jQuery('#add_rsyncmodule_path').val());
  if (rsyncmodule_path.length == 0) {
    ModelPathState = false;
    jQuery('#add_rsyncmodule_path').attr('class', 'unas_input_error');
    jQuery("#add_rsyncmodule_path_warning").text(UNAS._('##$@rsync@$##Folder path cannot be empty##$@rsync@$##'));
    checkAddModuleSubmit();
    return ModelPathState;
  }
  jQuery.ajax({
    url: "/apps/rsync/include/service_rsync.php",
    type: "POST",
    async: true,
    timeout: 20000,
    data: {
      "action": "checkPath",
      "path": rsyncmodule_path
    },
    dataType: "json",
    success: function(data) {
      if (data.status == 1) {
        ModelPathState = true;
        jQuery('#add_rsyncmodule_path').attr('class', 'unas_input');
        jQuery("#add_rsyncmodule_path_warning").text('');
        checkAddModuleSubmit();
        return ModelPathState;
      } else if (data.status == -1) {
        ModelPathState = false;
        jQuery('#add_rsyncmodule_path').attr('class', 'unas_input_error');
        jQuery("#add_rsyncmodule_path_warning").text(UNAS._('##$@rsync@$##The folder path does not exist##$@rsync@$##'));
        checkAddModuleSubmit();
        return ModelPathState;
      } else {
        ModelPathState = false;
        jQuery('#add_rsyncmodule_path').attr('class', 'unas_input_error');
        jQuery("#add_rsyncmodule_path_warning").text(UNAS._('##$@rsync@$##Other error##$@rsync@$##'));
        checkAddModuleSubmit();
        return ModelPathState;
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      ModelPathState = false;
      jQuery('#add_rsyncmodule_path').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_path_warning").text(UNAS._('##$@rsync@$##Request timeout##$@rsync@$##'));
      checkAddModuleSubmit();
      return ModelPathState;
    }
  });

}

function checkModuleUserInput() {
  var username = "";
  var reg = /^[a-zA-Z]{1}[a-zA-Z0-9_-]{0,127}$/;
  var rsyncmodule_name = jQuery.trim(jQuery('#add_rsyncmodule_user').val());
  if (rsyncmodule_name.length == 0) {
    jQuery('#add_rsyncmodule_user').attr('class', 'unas_input_error');
    jQuery("#add_rsyncmodule_user_warning").text(UNAS._('##$@rsync@$##The user name consists of English letters, underscores and numbers. The first character is a letter##$@rsync@$##'));
    jQuery("#add_rsyncmodule_user_warning_icon").attr('class', "unas_icon_error");
    jQuery("#add_rsyncmodule_user_warning_icon").attr('title', UNAS._('##$@rsync@$##The user name consists of English letters, underscores and numbers. The first character is a letter##$@rsync@$##'));
    ModelUserState = false;
    checkAddModuleSubmit();
    return ModelUserState;
  } else {
    if (rsyncmodule_name.length > 128) {
      jQuery('#add_rsyncmodule_user').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_user_warning").text(UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      jQuery("#add_rsyncmodule_user_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_user_warning_icon").attr('title', UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      ModelUserState = false;
      checkAddModuleSubmit();
      return ModelUserState;
    } else if (!reg.test(rsyncmodule_name)) {
      jQuery('#add_rsyncmodule_user').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_user_warning").text(UNAS._('##$@rsync@$##The user name consists of English letters, underscores and numbers. The first character is a letter##$@rsync@$##'));
      jQuery("#add_rsyncmodule_user_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_user_warning_icon").attr('title', UNAS._('##$@rsync@$##The user name consists of English letters, underscores and numbers. The first character is a letter##$@rsync@$##'));
      ModelUserState = false;
      checkAddModuleSubmit();
      return ModelUserState;
    }
  }
  ModelUserState = true;
  jQuery('#add_rsyncmodule_user').attr('class', 'unas_input');
  jQuery("#add_rsyncmodule_user_warning").text('');
  jQuery("#add_rsyncmodule_user_warning_icon").attr('class', "unas_icon");
  jQuery("#add_rsyncmodule_user_warning_icon").attr('title', '');
  checkAddModuleSubmit();
  return (ModelUserState);
}

function checkModulePasswordInput() {
  var password = "";
  //var reg = /^[a-zA-Z]{1}[a-zA-Z0-9_-]{0,127}$/;
  var reg = /^.*[\'\"].*$/;
  var password = jQuery.trim(jQuery('#add_rsyncmodule_password').val());
  if (password.length == 0) {
    jQuery('#add_rsyncmodule_password').attr('class', 'unas_input_error');
    jQuery("#add_rsyncmodule_password_warning").text(UNAS._("##$@rsync@$##The password must be shorter than 128 characters, and CANNOT use quotation mark in password##$@rsync@$##"));
    jQuery("#add_rsyncmodule_password_warning_icon").attr('class', "unas_icon_error");
    jQuery("#add_rsyncmodule_password_warning_icon").attr('title', UNAS._("##$@rsync@$##The password must be shorter than 128 characters, and CANNOT use quotation mark in password##$@rsync@$##"));
    ModelPwdState = false;
    checkAddModuleSubmit();
    return ModelPwdState;
  } else {
    if (password.length > 128) {
      jQuery('#add_rsyncmodule_password').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_password_warning").text(UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      jQuery("#add_rsyncmodule_password_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_password_warning_icon").attr('title', UNAS._('##$@rsync@$##The limit is 128 characters##$@rsync@$##'));
      ModelPwdState = false;
      checkAddModuleSubmit();
      return ModelPwdState;
    } else if (reg.test(password)) {
      jQuery('#add_rsyncmodule_password').attr('class', 'unas_input_error');
      jQuery("#add_rsyncmodule_password_warning").text(UNAS._("##$@rsync@$##The password must be shorter than 128 characters, and CANNOT use quotation mark in password##$@rsync@$##"));
      jQuery("#add_rsyncmodule_password_warning_icon").attr('class', "unas_icon_error");
      jQuery("#add_rsyncmodule_password_warning_icon").attr('title', UNAS._("##$@rsync@$##The password must be shorter than 128 characters, and CANNOT use quotation mark in password##$@rsync@$##"));
      ModelPwdState = false;
      checkAddModuleSubmit();
      return ModelPwdState;
    }
  }

  ModelPwdState = true;
  jQuery('#add_rsyncmodule_password').attr('class', 'unas_input');
  jQuery("#add_rsyncmodule_password_warning").text('');
  jQuery("#add_rsyncmodule_password_warning_icon").attr('class', "unas_icon");
  jQuery("#add_rsyncmodule_password_warning_icon").attr('title', '');
  checkAddModuleSubmit();
  return (ModelPwdState);
}

function checkAddModuleSubmit() {

  if ((jQuery.trim(jQuery('#add_rsyncmodule_name').val()) && ModelNameState) &&
    (jQuery.trim(jQuery('#add_rsyncmodule_path').val()) && ModelPathState) &&
    (jQuery.trim(jQuery('#add_rsyncmodule_user').val()) && ModelUserState) &&
    (jQuery.trim(jQuery('#add_rsyncmodule_password').val()) && ModelPwdState)
  ) {
    jQuery("#rsync_addmodule_enter").attr("class", "unas_button_sub");
  } else {
    jQuery("#rsync_addmodule_enter").attr("class", "unas_button_sub_disabled");
  }

}

function submit_addRsyncModule() {
  if (jQuery("#rsync_addmodule_enter").attr("class") == "unas_button_sub_disabled") {
    return false;
  }
  jQuery('#add_rsyncmodule_waiting_content').attr("style", "display:block");
  jQuery('#add_rsyncmodule_waiting_logo').attr("style", "display:block");
  var modulename = jQuery('#add_rsyncmodule_name').val();
  var path = jQuery('#add_rsyncmodule_path').val();
  var user = jQuery('#add_rsyncmodule_user').val();
  var password = jQuery('#add_rsyncmodule_password').val();
  jQuery.ajax({
    url: "/apps/rsync/include/service_rsync.php",
    type: "POST",
    async: true,
    data: {
      "modulename": modulename,
      "path": path,
      "user": user,
      "password": password,
      "action": "addRsyncModule"
    },
    timeout: 30000,
    success: function(data) {
      jQuery('#add_rsyncmodule_waiting_content').attr("style", "display:none");
      jQuery('#add_rsyncmodule_waiting_logo').attr("style", "display:none");
      getRsyncServerInfo();
      MUI.closeWindow(parent.document.getElementById('AddRsyncModuleWindow'));
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      jQuery('#add_rsyncmodule_waiting_content').attr("style", "display:none");
      jQuery('#add_rsyncmodule_waiting_logo').attr("style", "display:none");
    }
  });
}
jQuery("#add_rsyncmodule_select_path").click(function() {
  var val = jQuery("#add_rsyncmodule_iso_filetree").text();
  if (val != '') {
    jQuery("#add_rsyncmodule_iso_filetree").text("");
    GetAddModulePathTree();
  } else {
    GetAddModulePathTree();
    jQuery("#add_rsyncmodule_file_list").css("display", "block");
  }
});
jQuery("#add_rsyncmodule_file_list_top").click(function() {
  jQuery("#add_rsyncmodule_iso_filetree").text("");
  jQuery("#add_rsyncmodule_file_list").css("display", "none");
});

function GetAddModulePathTree() {
  jQuery(document).ready(function($) {
    $('#add_rsyncmodule_iso_filetree').fileTree({
      root: '/mnt/',
      script: '/apps/rsync/js/jstree/jqueryFileTree.php'
    }, function(dir) {
      $('#add_rsyncmodule_path').val(dir);
      checkModelPathInput();


    });
  });
}
(function() {
  jQuery("#add_rsyncmodule_file_list_content").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark",
    axis: "yx",
    autoDraggerLength: true,
    scrollButtons: true
  });
  jQuery("#add_rsyncmodule_file_list_content").mCustomScrollbar("update");

})();
